//+------------------------------------------------------------------+
//|                                                       eclock.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"
#property indicator_chart_window

extern color  colorNormal          = LimeGreen;
extern color  colorLate            = Red;
extern int    fontSize             = 10;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()   { EventSetMillisecondTimer(250);            return(0); }
int deinit() { EventKillTimer(); ObjectDelete("eclock"); return(0); }
int start()  {                                           return(0); }
void OnTimer() { ShowClock();}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void ShowClock()
{
   datetime TimeArray[];
   int    theColor;
   string time;
 
   RefreshRates();

   //
   //
   //
   //

   int diff = (int)MathRound((TimeCurrent()-TimeLocal())/3600.0)*3600;
         time = getTime((int)iTime(NULL,0,0)+Period()*60-(int)TimeLocal()-diff,theColor);

         //
         //
         //
         //
         //
                  
         if(ObjectFind("eclock") != 0)
            ObjectCreate("eclock",OBJ_TEXT,0,0,0);
            ObjectSetText("eclock","                                 "+time,fontSize, "Arial bold", theColor);
            double ShiftUp = iATR(NULL,0,50,0)/2.00;
               ObjectMove("eclock", 0,Time[0],Close[0]+ShiftUp);
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

string getTime(int times,int& theColor)
{
   string time = "";
   int    seconds;
   int    minutes;
   int    hours;
   
   //
   //
   //
   //
   //
   
   if (times < 0) {
         theColor = colorLate; times = MathAbs(times);}
   else  theColor = colorNormal;
   seconds = (times%60);
   hours   = (times-times%3600)/3600;
   minutes = (times-seconds)/60-hours*60;

   //
   //
   //
   //
   //
   
   if (hours>0)
   if (minutes < 10)
         time = StringConcatenate(time,hours,":0");
   else  time = StringConcatenate(time,hours,":");
         time = StringConcatenate(time,minutes);
   if (seconds < 10)
         time = StringConcatenate(time,":0",seconds);
   else  time = StringConcatenate(time,":" ,seconds);
   return(time);
}